from netgen.meshing import *
from netgen.stl import *

from ngsolve import ngsglobals
ngsglobals.msg_level = 2

geo1 = LoadSTLGeometry("t1g.stl") 
m1 = geo1.GenerateMesh (maxh=1)
m1.Save("t1g.vol")

geo2 = LoadSTLGeometry("t2g.stl") 
m2 = geo2.GenerateMesh (maxh=1)
m2.Save("t2g.vol")

print ("** merging suface meshes **")

spmesh = Mesh()

fd_1 = spmesh.Add (FaceDescriptor(bc=1,domin=1,surfnr=1))
fd_2 = spmesh.Add (FaceDescriptor(bc=2,domin=2,surfnr=2))

pmap1 = { }
for e1 in m1.Elements2D():
    for v1 in e1.vertices:
        if (v1 not in pmap1):
            pmap1[v1] = spmesh.Add (m1[v1])

for e1 in m1.Elements2D():
    spmesh.Add (Element2D (fd_1, [pmap1[v1] for v1 in e1.vertices]))

pmap2 = { }
for e2 in m2.Elements2D():
    for v2 in e2.vertices:
        if (v2 not in pmap2):
            pmap2[v2] = spmesh.Add (m2[v2])

for e2 in m2.Elements2D():
    spmesh.Add (Element2D (fd_2, [pmap2[v2] for v2 in e2.vertices]))

print ("** merging done **")

spmesh.GenerateVolumeMesh()
spmesh.Save ("newmesh.vol")
